//=============================================================================
// SupponRandomEnemyEmergence.js
//=============================================================================

/*:
 * @plugindesc Random Enemies emergence. Version 1.04
 * @author Suppon
 *
 * 
 * @help
 *
 * Plugin Command:
 *   supponREE ratio times id id id....       
 *   ratio : Emergence probability numer 
 *   times : Repetition number
 *   id    : Enemy ID
 *
 * Example
 *   supponREE 80 20 1 2 3 4
 *   
 *   Enter the sentence in Battle Event 1st page of Troops.
 *   It doesen't work when it put other page.
 *   Punctuate numbers by space, but don't put space at end.
 *   It can read and works more than 2 sentence at once.
 */

/*:ja
 * @plugindesc モンスターランダム出現です。
 * @author Suppon
 *
 * @help
 *
 * プラグインコマンド1:
 *   supponREE ratio times id id id・・・
 *   ratio : 出現確率％です。
 *   times : 繰り返す回数です。
 *   id    : エネミーのIDです。
 * 
 * 使用例
 *   supponREE 80 20 1 2 3 4
 * 
 * TroopsのBattle Eventの1ページ目に入れてください。ほかのページでは動きません。
 * 複数行いれてもOKです。数字はスペースで区切ってください。末尾にスペースを入れないでください。
 *
 *
 *
 *
 * プラグインコマンド2:エネミー出現位置調整用です。
 * 
 *   supponSetMargin 数字1 数字2 数字3 数字4
 *   数字1 : 画面上端のマージンです。
 *   数字2 : 画面上端のマージンです。
 *   数字3 : 画面上端のマージンです。
 *   数字4 : 画面上端のマージンです。
 * 使用例
 *   supponSetMargin 0 0 50 50
 * 
 * TroopsのBattle Eventの1ページ目に入れてください。ほかのページでは動きません。
 * 数字はスペースで区切ってください。末尾にスペースを入れないでください。
 */
(function() {

    var _Game_Troop_setup = Game_Troop.prototype.setup;
    Game_Troop.prototype.setup = function(troopId) {
        this.clear();
        this.marginTop=0;
        this.marginBottom=0;
        this.marginLeft=0;
        this.marginRight=0;
        
        this.supponReUsed = false
        this._troopId = troopId;
        var enemyNumber = 0;
        var lists = $dataTroops[this._troopId].pages[0].list;
        for (var i=0; i<lists.length; i++) {
            if (!lists[i].parameters[0] || !(lists[i].code === 356)){continue};
            var args = lists[i].parameters[0].split(" ")
            var command = args.shift();       
            if (command == "supponREE") {
                for (var j=0; j<args[1]; j++){
                if (args[0] > Math.randomInt(100) || enemyNumber == 0) {
                    var enemyId = args[2+Math.randomInt(args.length - 2)];
                    var enemy = new Game_Enemy(enemyId, 0, 0);
                    this._enemies.push(enemy);
                    enemyNumber++;
                    }             
                }
            } 
            if(command == "supponSetMargin" && args.length==4){
                this.marginTop=Number(args[0]);
                this.marginBottom=Number(args[1]);
                this.marginLeft=Number(args[2]);
                this.marginRight=Number(args[3]);
            }
        };
        if (enemyNumber>0) {
            this.makeUniqueNames();
            this.supponReUsed = true
            return;
        } else {
        _Game_Troop_setup.call(this, troopId);
        }    
    }
    
    Spriteset_Battle.prototype.supponReLinedUpEnemy = function(){
        console.log($gameTroop.marginTop, $gameTroop.marginBottom, $gameTroop.marginLeft, $gameTroop.marginRight);
        var graphicsWidth=Graphics.width-$gameTroop.marginLeft-$gameTroop.marginRight;
        var graphicsHeight=Graphics.height-$gameTroop.marginTop-$gameTroop.marginBottom;
        //var dx = ($gameTroop.marginLeft-$gameTroop.marginRight)/2;
        //var dy = ($gameTroop.marginBottom-$gameTroop.marginTop)/2;
        var dx = $gameTroop.marginLeft;
        var dy = $gameTroop.marginTop;
        console.log("g", graphicsWidth, graphicsHeight);
        console.log(dx, dy);
        var whole_x = 0;
        var depth = 0;
        this._enemySprites.reverse();
        this._enemySprites.forEach(function(sprite){
            var base_y = Math.round(graphicsHeight*0.7);
            depth = Math.round(graphicsHeight*0.15);           
            sprite._homeY = base_y;
            console.log("aaa", sprite._homeY);
            whole_x += Math.ceil(sprite.width * sprite.scale.x);
             });
        var line = Math.floor(whole_x / graphicsWidth)+1;
        var l = 0;
        var j = 1;
        var maxx = null;
        var minx = null;
        var size = this._enemySprites.length;
        var n = Math.ceil(size/line);
        this._enemySprites.forEach(function(sprite){
            l = Math.ceil(j/n);
            sprite._homeX = graphicsWidth*((j-1)%n)/(n*1.2);
            sprite._homeX += graphicsWidth*l/(n*1.2*line);
            sprite._homeY -= depth-(Math.ceil(depth*Math.pow(0.7,l)))
            console.log("bbb", sprite._homeY);
            if (j==1) {maxx = sprite._homeX; minx = sprite._homeX};
            if (maxx<sprite._homeX) {maxx=sprite._homeX};
            if (minx>sprite._homeX) {minx=sprite._homeY};
            j++;
        });
        var centerx = (maxx + minx)/2;
        var shiftx = (maxx + minx)/2-graphicsWidth/2;
        this._enemySprites.forEach(function(sprite){
            sprite._homeX -= shiftx;
            sprite._homeX += dx;
            sprite._homeY += dy;
            console.log("ccc", sprite._homeY);
            console.log(sprite._homeX, sprite._homeY);
        });
    };
    
    Spriteset_Battle.prototype.supponReLinedUpEnemySV = function(){
        var graphicsWidth=Graphics.width-$gameTroop.marginLeft-$gameTroop.marginRight;
        var graphicsHeight=Graphics.height-$gameTroop.marginTop-$gameTroop.marginBottom;
        var dx = $gameTroop.marginLeft;
        var dy = $gameTroop.marginTop;
        
        var whole_x = 0;
        var depth = 0;
        this._enemySprites.reverse();
        this._enemySprites.forEach(function(sprite){
            var base_y = Math.round(graphicsHeight*0.5);
            depth = Math.round(graphicsHeight*0.15);           
            sprite._homeY = base_y;
            whole_x += Math.ceil(sprite.width * sprite.scale.x);
             });
        var line = Math.floor(whole_x / graphicsWidth*2)+1;
        var l = 0;
        var j = 1;
        var size = this._enemySprites.length;
        this._enemySprites.forEach(function(sprite){
            l = Math.floor(line*(j-1)/size);
            sprite._homeX = (graphicsWidth/(1+size)*0.6)*(1+line*(j-1)%(size));
            sprite._homeY += (graphicsHeight/line*3)*(line-l*2)/15
            -(graphicsHeight/line*3)/30;
            j++;
        });
        this._enemySprites.forEach(function(sprite){
            sprite._homeX += dx;
            sprite._homeY += dy;
        });
    };
    
    var _Scene_Battle_update = Scene_Battle.prototype.update;
    Scene_Battle.prototype.update = function() {
        _Scene_Battle_update.call(this);
        if ($gameTroop.supponReUsed && !this.supponReLinedUpDone){
            if(this._spriteset.isAllBitmapReady()){
                if ($dataSystem.optSideView){
                    this._spriteset.supponReLinedUpEnemySV();
                } else {
                    this._spriteset.supponReLinedUpEnemy();
                }
                this.supponReLinedUpDone = true;
            }
        }
    };
    
    Spriteset_Battle.prototype.isAllBitmapReady = function(){
        return this._enemySprites.every(function(sprite){
            return sprite.bitmap.isReady()
        })
    }
    
})();